// (c) Bjrk Boye Busch - http://bjrk.net
using System;
using System.Collections.Generic;
using System.Text;
using TokenLibrary;
using Model_AST_Library;


namespace StateParserLibrary
{
    class ParserState_Medlem_Slut : ParserState
    {
        public ParserState_Medlem_Slut()
        {
            medlemsListe.medlemmer.Add(medlem);
            medlemSemantikOk(ref medlem);
            if (vis)
                Console.WriteLine("Medlem fundet:" + medlem);
        }
        public override ParserState Next()
        {
            switch (input.FirstToken().Typen)
            {
                case Token.Tokentype.Slut:
                    return new ParserState_Medlemliste_Slut();
                default:
                    return new ParseState_Medlem_Start();
            }
        }
        private void medlemSemantikOk(ref Medlem nyMedlem)
        {
            const int SENIOR_ALDER = 18;
            int alder = DateTime.Now.Year - nyMedlem.Fdselsr;
            switch (nyMedlem.Kategori)
            {
                case Medlem.KategoriType.Junior:
                    // REGEL 2: junior
                    // Sematisk check af konsistens mellem alder og kategori
                    if (SENIOR_ALDER <= alder)
                    {
                        fejl = true;
                        Console.WriteLine("Fejl i medlem '{0}'. Fdselsr og kategori stemmer ikke overens!", nyMedlem.ToString());
                    }
                    break;
                case Medlem.KategoriType.Senior:
                    // REGEL 2: senior
                    // Sematisk check af konsistens mellem alder og kategori
                    if (alder < SENIOR_ALDER)
                    {
                        fejl = true;
                        Console.WriteLine("Fejl i medlem '{0}'. Fdselsr og kategori stemmer ikke overens!", nyMedlem.ToString());
                    }
                    break;
                default: break;
            }
        }
    }
}
