﻿// (c) Bjørk Boye Busch - http://bjørk.net
using System;
using System.Collections.Generic;
using System.Text;
using TokenLibrary;
using StateParserLibrary;
using Model_AST_Library;


namespace StateParser_TestApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Demonstrerer isoleret Parser - token leveres fra en liste");

            List<Token> tokenList = new List<Token>();
            tokenList.Add(new Token(Token.Tokentype.Navn,"Bjørk",0));
            tokenList.Add(new Token(Token.Tokentype.Fødselsår,"1957",0));
            tokenList.Add(new Token(Token.Tokentype.Senior,"Senior",0));
            tokenList.Add(new Token(Token.Tokentype.Semikolon,";",0));
            tokenList.Add(new Token(Token.Tokentype.Navn, "Boye", 0));
            tokenList.Add(new Token(Token.Tokentype.Fødselsår, "1958", 0));
            tokenList.Add(new Token(Token.Tokentype.Junior, "Junior", 0));
            tokenList.Add(new Token(Token.Tokentype.Semikolon, ";", 0));
            tokenList.Add(new Token(Token.Tokentype.Navn, "Busch", 0));
            tokenList.Add(new Token(Token.Tokentype.Fødselsår, "1959", 0));
            tokenList.Add(new Token(Token.Tokentype.Semikolon, ";", 0));
            tokenList.Add(new Token(Token.Tokentype.Fødselsår, "1960", 0));
            tokenList.Add(new Token(Token.Tokentype.Semikolon, ";", 0));
            tokenList.Add(new Token(Token.Tokentype.Slut, "", 0));


            TokenReaderList tokenReader = new TokenReaderList(tokenList);
            StateParserControler parser = new StateParserControler(tokenReader, false);
            parser.ParseInput();
            Medlemsliste ml = parser.GetMedlemsliste();

            if (parser.PassedWithError())
                Console.WriteLine("Passed with ERROR");


            Console.WriteLine("\nMedlemsliste");
            foreach (Medlem m in ml.medlemmer)
            {
                Console.WriteLine(m);
            }

            Console.WriteLine("\n");
            Console.ReadLine();
        }
    }
}
